Index: /LMDZ5/branches/testing/libf/phylmd/add_phys_tend_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/add_phys_tend_mod.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/add_phys_tend_mod.F90	(revision 2870)
@@ -223,41 +223,17 @@
 
   if (fl_ebil .GT. 0) then
-  ! Reset variables
-    zqw_col(:,:) = 0.
-    zql_col(:,:) = 0.
-    zqs_col(:,:) = 0.
-    zek_col(:,:) = 0.
-    zh_dair_col(:,:) = 0.
-    zh_qw_col(:,:) = 0.
-    zh_ql_col(:,:) = 0.
-    zh_qs_col(:,:) = 0.
+    ! ------------------------------------------------
+    ! Compute vertical sum for each atmospheric column
+    ! ------------------------------------------------
+    n=1   ! begining of time step
 
     zcpvap = rcpv
     zcwat = rcw
     zcice = rcs
-!JLD    write (*,*) "rcpd, zcpvap, zcwat, zcice ",rcpd, zcpvap, zcwat, zcice
-  
-    ! ------------------------------------------------
-    ! Compute vertical sum for each atmospheric column
-    ! ------------------------------------------------
-    n=1   ! begining of time step
-    DO k = 1, klev
-      DO i = 1, klon
-        ! Watter mass
-        zqw_col(i,n) = zqw_col(i,n) + q_seri(i, k)*zairm(i, k)
-        zql_col(i,n) = zql_col(i,n) + ql_seri(i, k)*zairm(i, k)
-        zqs_col(i,n) = zqs_col(i,n) + qs_seri(i, k)*zairm(i, k)
-        ! Kinetic Energy
-        zek_col(i,n) = zek_col(i,n) + 0.5*(u_seri(i,k)**2+v_seri(i,k)**2)*zairm(i, k)
-        ! Air enthalpy : dry air, water vapour, liquid, solid
-        zh_dair_col(i,n) = zh_dair_col(i,n) + rcpd*(1.-q_seri(i,k)-ql_seri(i,k)-qs_seri(i,k))* &
-          zairm(i, k)*t_seri(i, k)
-        zh_qw_col(i,n) = zh_qw_col(i,n) +  zcpvap*t_seri(i, k)         *q_seri(i, k)*zairm(i, k)    !jyg
-        zh_ql_col(i,n) = zh_ql_col(i,n) + (zcpvap*t_seri(i, k) - rlvtt)*ql_seri(i, k)*zairm(i, k)   !jyg
-        zh_qs_col(i,n) = zh_qs_col(i,n) + (zcpvap*t_seri(i, k) - rlstt)*qs_seri(i, k)*zairm(i, k)   !jyg
-      END DO
-    END DO
-    ! compute total air enthalpy
-    zh_col(:,n) = zh_dair_col(:,n) + zh_qw_col(:,n) + zh_ql_col(:,n) + zh_qs_col(:,n)
+
+    CALL integr_v(klon, klev, zcpvap, &
+                  t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
 
   end if ! end if (fl_ebil .GT. 0)
@@ -465,22 +441,9 @@
     ! ------------------------------------------------
     n=2   ! end of time step
-    DO k = 1, klev
-      DO i = 1, klon
-        ! Watter mass
-        zqw_col(i,n) = zqw_col(i,n) + q_seri(i, k)*zairm(i, k)
-        zql_col(i,n) = zql_col(i,n) + ql_seri(i, k)*zairm(i, k)
-        zqs_col(i,n) = zqs_col(i,n) + qs_seri(i, k)*zairm(i, k)
-        ! Kinetic Energy
-        zek_col(i,n) = zek_col(i,n) + 0.5*(u_seri(i,k)**2+v_seri(i,k)**2)*zairm(i, k)
-        ! Air enthalpy : dry air, water vapour, liquid, solid
-        zh_dair_col(i,n) = zh_dair_col(i,n) + rcpd*(1.-q_seri(i,k)-ql_seri(i,k)-qs_seri(i,k))* &
-          zairm(i, k)*t_seri(i, k)
-        zh_qw_col(i,n) = zh_qw_col(i,n) +  zcpvap*t_seri(i, k)         *q_seri(i, k)*zairm(i, k)     !jyg
-        zh_ql_col(i,n) = zh_ql_col(i,n) + (zcpvap*t_seri(i, k) - rlvtt)*ql_seri(i, k)*zairm(i, k)    !jyg
-        zh_qs_col(i,n) = zh_qs_col(i,n) + (zcpvap*t_seri(i, k) - rlstt)*qs_seri(i, k)*zairm(i, k)    !jyg
-      END DO
-    END DO
-    ! compute total air enthalpy
-    zh_col(:,n) = zh_dair_col(:,n) + zh_qw_col(:,n) + zh_ql_col(:,n) + zh_qs_col(:,n)
+
+    CALL integr_v(klon, klev, zcpvap, &
+                  t_seri, q_seri, ql_seri, qs_seri, u_seri, v_seri, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
 
     ! ------------------------------------------------
@@ -517,4 +480,229 @@
   RETURN
 END SUBROUTINE add_phys_tend
+
+SUBROUTINE diag_phys_tend (nlon, nlev, uu, vv, temp, qv, ql, qs, &
+                          zdu,zdv,zdt,zdq,zdql,zdqs,paprs,text)
+!======================================================================
+! Ajoute les tendances des variables physiques aux variables 
+! d'etat de la dynamique t_seri, q_seri ...
+! On en profite pour faire des tests sur les tendances en question.
+!======================================================================
+
+
+!======================================================================
+! Declarations
+!======================================================================
+
+USE phys_state_var_mod, ONLY : dtime, ftsol
+USE geometry_mod, ONLY: longitude_deg, latitude_deg
+USE print_control_mod, ONLY: prt_level
+USE cmp_seri_mod
+USE phys_output_var_mod, ONLY : d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col &
+  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col
+IMPLICIT none
+  include "YOMCST.h"
+  include "clesphys.h"
+
+! Arguments :
+!------------
+INTEGER, INTENT(IN)                           :: nlon, nlev
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: uu, vv
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: temp, qv, ql, qs
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: zdu, zdv
+REAL, DIMENSION(nlon,nlev),     INTENT(IN)    :: zdt, zdq, zdql, zdqs
+REAL, DIMENSION(nlon,nlev+1),   INTENT(IN)    :: paprs
+CHARACTER*(*),                  INTENT(IN)    :: text
+
+! Local :
+!--------
+REAL, DIMENSION(nlon,nlev)      :: uu_n, vv_n
+REAL, DIMENSION(nlon,nlev)      :: temp_n, qv_n, ql_n, qs_n
+
+
+!
+INTEGER k, n
+
+integer debug_level
+logical, save :: first=.true.
+!$OMP THREADPRIVATE(first)
+!
+!======================================================================
+! Variables for energy conservation tests
+!======================================================================
+!
+
+! zh_col-------  total enthalpy of vertical air column
+! (air with watter vapour, liquid and solid) (J/m2)
+! zh_dair_col--- total enthalpy of dry air (J/m2)
+! zh_qw_col----  total enthalpy of watter vapour (J/m2)
+! zh_ql_col----  total enthalpy of liquid watter (J/m2)
+! zh_qs_col----  total enthalpy of solid watter  (J/m2)
+! zqw_col------  total mass of watter vapour (kg/m2)
+! zql_col------  total mass of liquid watter (kg/m2)
+! zqs_col------  total mass of solid watter (kg/m2)
+! zek_col------  total kinetic energy (kg/m2)
+!
+REAL zairm(nlon, nlev) ! layer air mass (kg/m2)
+REAL zqw_col(nlon,2)
+REAL zql_col(nlon,2)
+REAL zqs_col(nlon,2)
+REAL zek_col(nlon,2)
+REAL zh_dair_col(nlon,2)
+REAL zh_qw_col(nlon,2), zh_ql_col(nlon,2), zh_qs_col(nlon,2)
+REAL zh_col(nlon,2)
+
+!======================================================================
+! Initialisations
+
+     IF (prt_level >= 5) then
+        write (*,*) "In diag_phys_tend, after ",text
+        call flush
+     end if
+
+     debug_level=10
+     if (first) then
+        print *,"TestJLD rcpv, rcw, rcs",rcpv, rcw, rcs
+        first=.false.
+     endif
+!
+!  print *,'add_phys_tend: paprs ',paprs
+!======================================================================
+! Diagnostics for energy conservation tests
+!======================================================================
+  DO k = 1, nlev
+    ! layer air mass
+    zairm(:, k) = (paprs(:,k)-paprs(:,k+1))/rg
+  END DO
+
+  if (fl_ebil .GT. 0) then
+    ! ------------------------------------------------
+    ! Compute vertical sum for each atmospheric column
+    ! ------------------------------------------------
+    n=1   ! begining of time step
+
+    CALL integr_v(nlon, nlev, rcpv, &
+                  temp, qv, ql, qs, uu, vv, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+
+  end if ! end if (fl_ebil .GT. 0)
+
+!======================================================================
+! Ajout des tendances sur le vent, la temperature et les diverses phases de l'eau
+!======================================================================
+
+     uu_n(:,:)=uu(:,:)+zdu(:,:)
+     vv_n(:,:)=vv(:,:)+zdv(:,:)
+     qv_n(:,:)=qv(:,:)+zdq(:,:)
+     ql_n(:,:)=ql(:,:)+zdql(:,:)
+     qs_n(:,:)=qs(:,:)+zdqs(:,:)
+     temp_n(:,:)=temp(:,:)+zdt(:,:)
+
+
+
+!======================================================================
+! Diagnostics for energy conservation tests
+!======================================================================
+
+  if (fl_ebil .GT. 0) then
+  
+    ! ------------------------------------------------
+    ! Compute vertical sum for each atmospheric column
+    ! ------------------------------------------------
+    n=2   ! end of time step
+
+    CALL integr_v(nlon, nlev, rcpv, &
+                  temp_n, qv_n, ql_n, qs_n, uu_n, vv_n, zairm, &
+                    zqw_col(:,n), zql_col(:,n), zqs_col(:,n), zek_col(:,n), zh_dair_col(:,n), &
+                    zh_qw_col(:,n), zh_ql_col(:,n), zh_qs_col(:,n), zh_col(:,n))
+
+    ! ------------------------------------------------
+    ! Compute the changes by unit of time
+    ! ------------------------------------------------
+
+    d_qw_col(:) = (zqw_col(:,2)-zqw_col(:,1))/dtime
+    d_ql_col(:) = (zql_col(:,2)-zql_col(:,1))/dtime
+    d_qs_col(:) = (zqs_col(:,2)-zqs_col(:,1))/dtime
+    d_qt_col(:) = d_qw_col(:) + d_ql_col(:) + d_qs_col(:)
+
+    d_ek_col(:) = (zek_col(:,2)-zek_col(:,1))/dtime
+
+   print *,'zdu ', zdu
+   print *,'zdv ', zdv
+   print *,'d_ek_col, zek_col(2), zek_col(1) ',d_ek_col(1), zek_col(1,2), zek_col(1,1)
+
+    d_h_dair_col(:) = (zh_dair_col(:,2)-zh_dair_col(:,1))/dtime
+    d_h_qw_col(:) = (zh_qw_col(:,2)-zh_qw_col(:,1))/dtime
+    d_h_ql_col(:) = (zh_ql_col(:,2)-zh_ql_col(:,1))/dtime
+    d_h_qs_col(:) = (zh_qs_col(:,2)-zh_qs_col(:,1))/dtime
+
+    d_h_col = (zh_col(:,2)-zh_col(:,1))/dtime 
+
+  end if ! end if (fl_ebil .GT. 0)
+!
+
+  RETURN
+END SUBROUTINE diag_phys_tend
+
+SUBROUTINE integr_v(nlon, nlev, zcpvap, &
+                    temp, qv, ql, qs, uu, vv, zairm,  &
+                    zqw_col, zql_col, zqs_col, zek_col, zh_dair_col, &
+                    zh_qw_col, zh_ql_col, zh_qs_col, zh_col)
+
+IMPLICIT none
+  include "YOMCST.h"
+
+INTEGER,                    INTENT(IN)    :: nlon,nlev
+REAL,                       INTENT(IN)    :: zcpvap
+REAL, DIMENSION(nlon,nlev), INTENT(IN)    :: temp, qv, ql, qs, uu, vv
+REAL, DIMENSION(nlon,nlev), INTENT(IN)    :: zairm
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zqw_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zql_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zqs_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zek_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_dair_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_qw_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_ql_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_qs_col
+REAL, DIMENSION(nlon),      INTENT(OUT)   :: zh_col
+
+INTEGER          :: i, k
+
+
+  ! Reset variables
+    zqw_col(:) = 0.
+    zql_col(:) = 0.
+    zqs_col(:) = 0.
+    zek_col(:) = 0.
+    zh_dair_col(:) = 0.
+    zh_qw_col(:) = 0.
+    zh_ql_col(:) = 0.
+    zh_qs_col(:) = 0.
+
+!JLD    write (*,*) "rcpd, zcpvap, zcwat, zcice ",rcpd, zcpvap, zcwat, zcice
+  
+    ! ------------------------------------------------
+    ! Compute vertical sum for each atmospheric column
+    ! ------------------------------------------------
+    DO k = 1, nlev
+      DO i = 1, nlon
+        ! Watter mass
+        zqw_col(i) = zqw_col(i) + qv(i, k)*zairm(i, k)
+        zql_col(i) = zql_col(i) + ql(i, k)*zairm(i, k)
+        zqs_col(i) = zqs_col(i) + qs(i, k)*zairm(i, k)
+        ! Kinetic Energy
+        zek_col(i) = zek_col(i) + 0.5*(uu(i,k)**2+vv(i,k)**2)*zairm(i, k)
+        ! Air enthalpy : dry air, water vapour, liquid, solid
+        zh_dair_col(i) = zh_dair_col(i) + rcpd*(1.-qv(i,k)-ql(i,k)-qs(i,k))* &
+                                               zairm(i, k)*temp(i, k)
+        zh_qw_col(i) = zh_qw_col(i) +  zcpvap*temp(i, k)         *qv(i, k)*zairm(i, k)    !jyg
+        zh_ql_col(i) = zh_ql_col(i) + (zcpvap*temp(i, k) - rlvtt)*ql(i, k)*zairm(i, k)   !jyg
+        zh_qs_col(i) = zh_qs_col(i) + (zcpvap*temp(i, k) - rlstt)*qs(i, k)*zairm(i, k)   !jyg
+      END DO
+    END DO
+    ! compute total air enthalpy
+    zh_col(:) = zh_dair_col(:) + zh_qw_col(:) + zh_ql_col(:) + zh_qs_col(:)
+
+END SUBROUTINE integr_v
 
 SUBROUTINE prt_enerbil (text, itap)
@@ -624,7 +812,12 @@
       write(*,9000) text,"enerbil: snow, bil_lat, bil_sens", snow_lsc(1), rlstt * snow_lsc(1), -(rcs-rcpd)*t_seri(1,1) * snow_lsc(1)
     end if
+  CASE("convection") specific_diag
+    if ( prt_level .GE. 5) then
+      write(*,9000) text,"enerbil: rain, bil_lat, bil_sens", rain_con(1), rlvtt * rain_con(1), -(rcw-rcpd)*t_seri(1,1) * rain_con(1)
+      write(*,9000) text,"enerbil: snow, bil_lat, bil_sens", snow_con(1), rlstt * snow_con(1), -(rcs-rcpd)*t_seri(1,1) * snow_con(1)
+    end if
   END SELECT specific_diag
 
-9000 format (1x,A8,2x,A30,10E15.6)
+9000 format (1x,A8,2x,A35,10E15.6)
 
 end if ! end if (fl_ebil .GT. 0)
Index: /LMDZ5/branches/testing/libf/phylmd/calwake.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/calwake.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/calwake.F90	(revision 2870)
@@ -54,5 +54,6 @@
   ! ------
   REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: dt_wake, dq_wake
-  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_k
+!!jyg  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_k
+  INTEGER, DIMENSION(klon),      INTENT (OUT)        :: wake_k
   REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_d_deltat_gw
   REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_h
Index: /LMDZ5/branches/testing/libf/phylmd/climb_hq_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/climb_hq_mod.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/climb_hq_mod.F90	(revision 2870)
@@ -221,5 +221,6 @@
 !****************************************************************************************
 !!! jyg le 07/02/2012
-       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+!!jyg       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+       IF (mod(iflag_pbl_split,10) .ge.1) THEN
 !!! nrlmd le 02/05/2011
     DO k= 1, klev
@@ -240,5 +241,5 @@
     ENDDO
 !!!      
-       ENDIF  ! (mod(iflag_pbl_split,2) .eq.1)
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
 !!!
 
@@ -377,5 +378,6 @@
 
 !!! jyg le 07/02/2012
-       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+!!jyg       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+       IF (mod(iflag_pbl_split,10) .ge.1) THEN
 !!! nrlmd le 02/05/2011
     DO i = 1, knon
@@ -399,5 +401,5 @@
     ENDDO
 !!!      
-       ENDIF  ! (mod(iflag_pbl_split,2) .eq.1)
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
 !!!
 
Index: /LMDZ5/branches/testing/libf/phylmd/climb_wind_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/climb_wind_mod.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/climb_wind_mod.F90	(revision 2870)
@@ -172,5 +172,6 @@
 !****************************************************************************************
 !!! jyg le 07/02/2012
-       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+!!jyg       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+       IF (mod(iflag_pbl_split,10) .ge.1) THEN
 !!! nrlmd le 02/05/2011
     DO k= 1, klev
@@ -188,5 +189,5 @@
     ENDDO
 !!!      
-       ENDIF  ! (mod(iflag_pbl_split,2) .eq.1)
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
 !!!
 
@@ -308,5 +309,6 @@
 
 !!! jyg le 07/02/2012
-       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+!!jyg       IF (mod(iflag_pbl_split,2) .eq.1) THEN
+       IF (mod(iflag_pbl_split,10) .ge.1) THEN
 !!! nrlmd le 02/05/2011
     DO i = 1, knon
@@ -326,5 +328,5 @@
     ENDDO
 !!!
-       ENDIF  ! (mod(iflag_pbl_split,2) .eq.1)
+       ENDIF  ! (mod(iflag_pbl_split,2) .ge.1)
 !!!
 
Index: /LMDZ5/branches/testing/libf/phylmd/concvl.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/concvl.F90	(revision 2870)
@@ -13,5 +13,5 @@
 !RomP >>>
 !!     .             da,phi,mp,dd_t,dd_q,lalim_conv,wght_th)
-                  da, phi, mp, phi2, d1a, dam, sij, clw, elij, &     ! RomP
+                  da, phi, mp, phii, d1a, dam, sij, clw, elij, &     ! RomP
                   dd_t, dd_q, lalim_conv, wght_th, &                 ! RomP
                   evap, ep, epmlmMm, eplaMm, &                       ! RomP
@@ -87,84 +87,92 @@
   include "clesphys.h"
 
-  INTEGER iflag_clos
-
-  REAL dtime, paprs(klon, klev+1), pplay(klon, klev)
-  INTEGER k_upper_cv
-  REAL t(klon, klev), q(klon, klev), u(klon, klev), v(klon, klev)
-  REAL t_wake(klon, klev), q_wake(klon, klev)
-  REAL s_wake(klon)
-  REAL tra(klon, klev, nbtr)
-  INTEGER ntra
-  REAL sig1(klon, klev), w01(klon, klev), ptop2(klon)
-  REAL pmflxr(klon, klev+1), pmflxs(klon, klev+1)
-  REAL Ale(klon), Alp(klon)
-
-  REAL d_t(klon, klev), d_q(klon, klev), d_u(klon, klev), d_v(klon, klev)
-  REAL dd_t(klon, klev), dd_q(klon, klev)
-  REAL d_tra(klon, klev, nbtr)
-  REAL rain(klon), snow(klon)
-
-  INTEGER kbas(klon), ktop(klon)
-  REAL em_ph(klon, klev+1), em_p(klon, klev)
-  REAL upwd(klon, klev), dnwd(klon, klev), dnwdbis(klon, klev)
-
-!!       REAL Ma(klon,klev), mip(klon,klev),Vprecip(klon,klev)     !jyg
-  REAL Ma(klon, klev), mip(klon, klev), Vprecip(klon, klev+1)      !jyg
-  REAL Vprecipi(klon, klev+1)                                      !jyg
-  REAL wght(klon, klev)                                            !RL
-
-  REAL da(klon, klev), phi(klon, klev, klev), mp(klon, klev)
+  INTEGER, INTENT(IN)                           :: iflag_clos
+  REAL, INTENT(IN)                              :: dtime
+  REAL, DIMENSION(klon,klev),   INTENT(IN)      :: pplay
+  REAL, DIMENSION(klon,klev+1), INTENT(IN)      :: paprs
+  INTEGER,                      INTENT(IN)      :: k_upper_cv
+  REAL, DIMENSION(klon,klev),   INTENT(IN)      :: t, q, u, v
+  REAL, DIMENSION(klon,klev),   INTENT(IN)      :: t_wake, q_wake
+  REAL, DIMENSION(klon),        INTENT(IN)      :: s_wake
+  REAL, DIMENSION(klon,klev, nbtr),INTENT(IN)   :: tra
+  INTEGER,                      INTENT(IN)      :: ntra
+  REAL, DIMENSION(klon),        INTENT(IN)      :: Ale, Alp
+!CR:test: on passe lentr et alim_star des thermiques
+  INTEGER, DIMENSION(klon),     INTENT(IN)      :: lalim_conv
+  REAL, DIMENSION(klon,klev),   INTENT(IN)      :: wght_th
+
+  REAL, DIMENSION(klon,klev),   INTENT(INOUT)   :: sig1, w01
+
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d_t, d_q, d_u, d_v
+  REAL, DIMENSION(klon,klev, nbtr),INTENT(OUT)  :: d_tra
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: rain, snow
+
+  INTEGER, DIMENSION(klon),     INTENT(OUT)     :: kbas, ktop
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: sigd
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: cbmf, plcl, plfc, wbeff
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: convoccur
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: upwd, dnwd, dnwdbis
+
+!!       REAL Ma(klon,klev), mip(klon,klev),Vprecip(klon,klev)                    !jyg
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: Ma, mip 
+  REAL, DIMENSION(klon,klev+1), INTENT(OUT)     :: Vprecip                        !jyg
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: cape, cin
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: tvp
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: Tconv
+  INTEGER, DIMENSION(klon),     INTENT(OUT)     :: iflag
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: pbase, bbase
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: dtvpdt1, dtvpdq1
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: dplcldt, dplcldr
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: qcondc
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: wd
+  REAL, DIMENSION(klon,klev+1), INTENT(OUT)     :: pmflxr, pmflxs
+
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: da, mp
+  REAL, DIMENSION(klon,klev,klev),INTENT(OUT)   :: phi
 ! RomP >>>
-  REAL phi2(klon, klev, klev)
-  REAL d1a(klon, klev), dam(klon, klev)
-  REAL sij(klon, klev, klev), clw(klon, klev), elij(klon, klev, klev)
-  REAL wdtrainA(klon, klev), wdtrainM(klon, klev)
-  REAL evap(klon, klev), ep(klon, klev)
-  REAL epmlmMm(klon, klev, klev), eplaMm(klon, klev)
+  REAL, DIMENSION(klon,klev,klev),INTENT(OUT)   :: phii
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: d1a, dam
+  REAL, DIMENSION(klon,klev,klev),INTENT(OUT)   :: sij, elij
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: clw
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: dd_t, dd_q
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: evap, ep
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: eplaMm
+  REAL, DIMENSION(klon,klev,klev), INTENT(OUT)  :: epmlmMm
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: wdtrainA, wdtrainM
 ! RomP <<<
-  REAL cape(klon), cin(klon), tvp(klon, klev)
-  REAL Tconv(klon, klev)
-
-!CR:test: on passe lentr et alim_star des thermiques
-  INTEGER lalim_conv(klon)
-  REAL wght_th(klon, klev)
-  REAL em_sig1feed ! sigma at lower bound of feeding layer
-  REAL em_sig2feed ! sigma at upper bound of feeding layer
-  REAL em_wght(klev) ! weight density determining the feeding mixture
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: wght                       !RL
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: qtc
+  REAL, DIMENSION(klon,klev),   INTENT(OUT)     :: sigt
+  REAL,                         INTENT(OUT)     :: tau_cld_cv, coefw_cld_cv
+  REAL, DIMENSION(klon),        INTENT(OUT)     :: epmax_diag                ! epmax_cape
+
+!
+!  Local
+!  ----
+  REAL, DIMENSION(klon,klev)                    :: em_p
+  REAL, DIMENSION(klon,klev+1)                  :: em_ph
+  REAL                                          :: em_sig1feed ! sigma at lower bound of feeding layer
+  REAL                                          :: em_sig2feed ! sigma at upper bound of feeding layer
+  REAL, DIMENSION(klev)                         :: em_wght ! weight density determining the feeding mixture
+  REAL, DIMENSION(klon,klev+1)                  :: Vprecipi                       !jyg
 !on enleve le save
 ! SAVE em_sig1feed,em_sig2feed,em_wght
 
-  INTEGER iflag(klon)
-  REAL rflag(klon)
-  REAL pbase(klon), bbase(klon)
-  REAL dtvpdt1(klon, klev), dtvpdq1(klon, klev)
-  REAL dplcldt(klon), dplcldr(klon)
-  REAL qcondc(klon, klev)
-  REAL qtc(klon, klev)
-  REAL sigt(klon, klev)
-  REAL wd(klon)
-  REAL plim1(klon), plim2(klon), asupmax(klon, klev)
-  REAL supmax0(klon), asupmaxmin(klon)
-
-  REAL sigd(klon)
-  REAL zx_t, zdelta, zx_qs, zcor
-  REAL tau_cld_cv, coefw_cld_cv
-  REAL epmax_diag(klon) ! epmax_cape
-
+  REAL, DIMENSION(klon)                         :: rflag
+  REAL, DIMENSION(klon)                         :: plim1, plim2
+  REAL, DIMENSION(klon)                         :: ptop2
+  REAL, DIMENSION(klon,klev)                    :: asupmax
+  REAL, DIMENSION(klon)                         :: supmax0, asupmaxmin
+  REAL                                          :: zx_t, zdelta, zx_qs, zcor
+!
 !   INTEGER iflag_mix
 !   SAVE iflag_mix
-  INTEGER noff, minorig
-  INTEGER i, k, itra
-  REAL qs(klon, klev), qs_wake(klon, klev)
-  REAL cbmf(klon), plcl(klon), plfc(klon), wbeff(klon)
-  REAL convoccur(klon)
+  INTEGER                                       :: noff, minorig
+  INTEGER                                       :: i,j, k, itra
+  REAL, DIMENSION(klon,klev)                    :: qs, qs_wake
 !LF          SAVE cbmf
 !IM/JYG      REAL, SAVE, ALLOCATABLE :: cbmf(:)
 !!!$OMP THREADPRIVATE(cbmf)!
-  REAL cbmflast(klon)
-  INTEGER ifrst
-  SAVE ifrst
-  DATA ifrst/0/
-!$OMP THREADPRIVATE(ifrst)
+  REAL, DIMENSION(klon)                         :: cbmflast
 
 
@@ -259,6 +267,4 @@
   snow(:) = 0
 
-! IF (ifrst .EQ. 0) THEN
-! ifrst = 1
   IF (first) THEN
     first = .FALSE.
@@ -293,5 +299,5 @@
       sigd(i) = 0.
     END DO
-  END IF !(ifrst .EQ. 0)
+  END IF !(first)
 
 ! Initialisation a chaque pas de temps
@@ -393,5 +399,5 @@
                    kbas, ktop, &
                    dtime, Ma, upwd, dnwd, dnwdbis, qcondc, wd, cape, &
-                   da, phi, mp, phi2, d1a, dam, sij, clw, elij, &       !RomP
+                   da, phi, mp, phii, d1a, dam, sij, clw, elij, &       !RomP
                    evap, ep, epmlmMm, eplaMm, &                         !RomP
                    wdtrainA, wdtrainM, &                                !RomP
@@ -428,7 +434,7 @@
                     asupmaxmin, lalim_conv, &
 !AC!+!RomP+jyg
-!!                   da,phi,mp,phi2,d1a,dam,sij,clw,elij, &               ! RomP
+!!                   da,phi,mp,phii,d1a,dam,sij,clw,elij, &               ! RomP
 !!                   evap,ep,epmlmMm,eplaMm,                              ! RomP
-                    da, phi, mp, phi2, d1a, dam, sij, wght, &           ! RomP+RL
+                    da, phi, mp, phii, d1a, dam, sij, wght, &           ! RomP+RL
                     clw, elij, evap, ep, epmlmMm, eplaMm, &             ! RomP+RL
                     wdtrainA, wdtrainM, qtc, sigt, &
Index: /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2869)
+++ /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2870)
@@ -1369,10 +1369,10 @@
     !
     !Config Key  = iflag_pbl_split
-    !Config Desc = binary flag: least signif bit = split vdf; next bit = split thermals
+    !Config Desc = decimal flag: least signif digit = split vdf; next digit = split thermals
     !Config Def  = 0
-    !Config Help = 0-> no splitting; 1-> vdf splitting; 2-> thermals splitting; 3-> full splitting
+    !Config Help = 0-> no splitting; 1-> vdf splitting; 10-> thermals splitting; 11-> full splitting
     !
     iflag_pbl_split_omp = 0
-    CALL getin('iflag_pbl_split',iflag_pbl_split_omp)
+    call getin('iflag_pbl_split',iflag_pbl_split_omp)
     !
     !Config Key  = iflag_order2_sollw
